bVerbose = false --debugging info
bLoaded = false --don't do anything until we are fully loaded, including savedvariables

--[[
//achievement "tada"
CHAT_MSG_ACHIEVEMENT (nearby)
CHAT_MSG_GUILD_ACHIEVEMENT

//leader
CHAT_MSG_OFFICER (other guild channel)
CHAT_MSG_PARTY_LEADER
CHAT_MSG_BATTLEGROUND_LEADER
CHAT_MSG_RAID_LEADER
CHAT_MSG_RAID_WARNING

//breath
MIRROR_TIMER_START (breath) "lub-dub"
MIRROR_TIMER_UPDATE

//mail
UPDATE_PENDING_MAIL "mail"
--]]

--use new Default tables to deal with upgrades
_G.DefaultChannel = {"Guild","Party","Whisper","Say","Yell","Emote","RealID","Danger","Timer"} --the internal list of channels
--_G.ChatOrder = {"Guild","Party","RealID","Danger","Whisper","Say","Yell","Emote"} --the order we present them
_G.DefaultEvent = {
	Guild="CHAT_MSG_GUILD GUILD_MOTD",
	Party="CHAT_MSG_PARTY CHAT_MSG_TARGETICONS PARTY_LOOT_METHOD_CHANGED PARTY_CONVERTED_TO_RAID CHAT_MSG_RAID RAID_TARGET_UPDATE CHAT_MSG_BATTLEGROUND CHAT_MSG_MONSTER_PARTY",
	Whisper="CHAT_MSG_WHISPER CHAT_MSG_MONSTER_WHISPER CHAT_MSG_RAID_BOSS_WHISPER",
	Say="CHAT_MSG_SAY CHAT_MSG_MONSTER_SAY CHAT_MSG_MONSTER_PARTY",
	Yell="CHAT_MSG_YELL CHAT_MSG_MONSTER_YELL",
	Emote="CHAT_MSG_EMOTE CHAT_MSG_TEXT_EMOTE CHAT_MSG_MONSTER_EMOTE CHAT_MSG_RAID_BOSS_EMOTE",
	RealID="CHAT_MSG_BN_WHISPER CHAT_MSG_BN_CONVERSATION",
	Danger="PLAYER_REGEN_DISABLED UNIT_SPELLCAST_CHANNEL_START UNIT_SPELLCAST_START", --UNIT_SPELLCAST_INTERRUPTIBLE
	Timer="MIRROR_TIMER_START MIRROR_TIMER_PAUSE MIRROR_TIMER_STOP",
	}
_G.DefaultSound = {Guild="Guild-Yo.ogg",Party="Party-Hey.ogg",Whisper="TellMessage",Say="Say-Blah.ogg",Yell="Yell-Blarg.ogg",Emote="Emote-Rowl.ogg",RealID="Whisper-Psst.ogg",Danger="Danger-Uhoh.ogg",Timer="Breath-Lubdub.ogg"} --default sounds
--_G.StateEnum = {"Off","Int","Ext"}
_G.DefaultState = {Guild="2",Party="2",Whisper="1",Say="2",Yell="2",Emote="2",RealID="2",Danger="2",Timer="2"} --default off,internal,external
_G.LimitEnum = {"Guild","Party","Friend","NPC","Target"} --raid,battleground?
_G.DefaultLimit = {
	Guild={Guild="0",Party="-1",Friend="-1",NPC="-1",Target="-1"}, --show disabled checks with -1
	Party={Guild="-1",Party="0",Friend="-1",NPC="-1",Target="-1"},
	Whisper={Guild="0",Party="0",Friend="0",NPC="0",Target="-1"}, --no limit means everybody (even strangers)
	Say={Guild="1",Party="1",Friend="1",NPC="1",Target="-1"}, --enable everyone except strangers
	Yell={Guild="1",Party="1",Friend="1",NPC="1",Target="-1"},
	Emote={Guild="0",Party="0",Friend="0",NPC="0",Target="-1"},
	RealID={Guild="-1",Party="-1",Friend="-1",NPC="-1",Target="-1"},
	Danger={Guild="-1",Party="-1",Friend="-1",NPC="-1",Target="1"},
	Timer={Guild="-1",Party="-1",Friend="-1",NPC="-1",Target="-1"},
	}
_G.LimitFunc = { --defined later
	}
--the names used for display are now in _G.ChatName in the localization file

--these are the saved vars
_G.ChatChannel = {}
_G.ChatEvent = {}
_G.ChatSound = {}
_G.ChatState = {}
_G.ChatLimit = {}

_G.ChatVersion = 0 --assume no version before

--statics for OnUpdate of Mirror timers
_G.TimerType = 0
_G.TimerStart = 0
_G.TimerCurrent = 0
_G.TimerTotal = 0

SoundFilePrefix = "Interface\\AddOns\\Brigand_Chatterbox\\"

--these are the slash commands (no setting limits yet)
SLASH_BRIGAND_CHATTERBOX1 = '/bcb';
SlashCmdList["BRIGAND_CHATTERBOX"] = function( msg, editbox )
	--InterfaceOptionsFrame_OpenToCategory(Brigand_Chatterbox_Frame)
	
	if (bVerbose) then
		ChatFrame1:AddMessage( "Brigand_Chatterbox received:'" .. msg .. "'" )
	end
	
	local channel, space1, onoff, space2, sound = msg:match("(%a+)(%s*)(%d?)(%s*)([%a%p]*)")--("(%a+)(%s*)(%d?)(%s*)(%a*)")--("%w+")--("(%w+)(%s*)")--("^(%S*)%s*(.-)$")--
	
	if (bVerbose) then
		ChatFrame1:AddMessage( "Brigand_Chatterbox parsed:" )
		if (channel ~= nil) then
			ChatFrame1:AddMessage( "'" .. channel .. "'" )
		end
		if (space1 ~= nil) then
			ChatFrame1:AddMessage( "'" .. space1 .. "'" )
		end
		if (onoff ~= nil) then
			ChatFrame1:AddMessage( "'" .. onoff .. "'" )
		end
		if (space2 ~= nil) then
			ChatFrame1:AddMessage( "'" .. space2 .. "'" )
		end
		if (sound ~= nil) then
			ChatFrame1:AddMessage( "'" .. sound .. "'" )
		end
	end --bVerbose
	
	--report all channels
	local reportall = false
	if (channel == nil) then
		reportall = true
	elseif( channel:len() == 0) then
		reportall = true
	end
	
	if( reportall ) then
		ChatFrame1:AddMessage("Brigand_Chatterbox report all:")
		--InterfaceOptionsFrame_OpenToCategory(Brigand_Chatterbox_Options)
		for i = 1, #_G.ChatChannel do
			ChatFrame1:AddMessage( _G.ChatName[_G.ChatChannel[i]] .. " " .. _G.ChatState[_G.ChatChannel[i]] .. " " .. _G.ChatSound[_G.ChatChannel[i]] )
		end
	else
		channel = channel:upper() --case insensitive
	end --reportall

	--report named channel
	local reportone = false
	if (onoff == nil) then
		reportone = true
	elseif (onoff:len() == 0) then
		reportone = true
	end
	
	if (reportone and not reportall ) then
		if (channel:upper() == "HELP") then
			ChatFrame1:AddMessage("Brigand_Chatterbox help:")

			ChatFrame1:AddMessage("'/bcb' reports current settings for all channels")
			
			ChatFrame1:AddMessage("'/bcb channel' reports current settings for one channel")
			local channellist = _G.ChatName[_G.ChatChannel[1]]
			for i = 2, #_G.ChatChannel do
				channellist = channellist .. ", " .. _G.ChatName[_G.ChatChannel[i]]
			end
			ChatFrame1:AddMessage("               valid channels are: " .. channellist)
			
			ChatFrame1:AddMessage("")
			ChatFrame1:AddMessage("'/bcb channel onoff' sets named channel on or off")
			ChatFrame1:AddMessage("               valid onoffs are: 0 (off), 1 (on), 2 (on for external)")
			
			ChatFrame1:AddMessage("")
			ChatFrame1:AddMessage("'/bcb channel onoff sound' sets channel on or off and defines sound to use")
			ChatFrame1:AddMessage("               use onoff '1' for internal sound name Eg. 'TellMessage'")
			ChatFrame1:AddMessage("               use onoff '2' for external sound file Eg. 'Guild-Yo.ogg'")
			ChatFrame1:AddMessage("               (folder 'Interface/AddOns/Brigand_Chatterbox/' will be pre-pended")
		else
			ChatFrame1:AddMessage("Brigand_Chatterbox report one:")
			for i = 1, #_G.ChatChannel do
				if( _G.ChatName[_G.ChatChannel[i]]:upper() == channel ) then --compare upper cases
					ChatFrame1:AddMessage( _G.ChatName[_G.ChatChannel[i]] .. " " .. _G.ChatState[_G.ChatChannel[i]] .. " " .. _G.ChatSound[_G.ChatChannel[i]] )
					break --out of for
				end
			end
		end -- help
	else
		if (onoff ~= "1" and onoff ~= "2") then --only "0" (off) or "1" (internal) or "2" (external)
			onoff = "0"
		end
	end --reportone
	
	--set one channel
	local setsound = true
	if (sound == nil) then
		setsound = false
	elseif (sound:len() == 0) then
		setsound = false
	end
	
	local setchannel = not (reportall or reportone)
	if (setchannel) then
		local index
		for i = 1, #_G.ChatChannel do
			if( _G.ChatName[_G.ChatChannel[i]]:upper() == channel ) then --compare upper cases
				index = i
				_G.ChatState[_G.ChatChannel[index]] = onoff
				
				if (setsound) then
					_G.ChatSound[_G.ChatChannel[index]] = sound
				end
				break --out of for
			end
		end

		--concatenate result string
		local result = "'" .. _G.ChatName[_G.ChatChannel[index]] .. "' to"
		if (onoff == "0") then
			result = result .. " 'off'"
		elseif (onoff == "1") then
			result = result .. " 'internal'"
		else
			result = result .. " 'external'"
		end

		result = result .. " sound '" .. _G.ChatSound[_G.ChatChannel[index]] .. "'"

		ChatFrame1:AddMessage("Brigand_Chatterbox set:" .. result )
	end --setchannel
end
	

--this is the frame that actually does the work
function Brigand_Chatterbox_OnLoad(frame)
	if (bVerbose) then
		ChatFrame1:AddMessage("Brigand_Chatterbox:OnLoad")
	end
	
	--I/O is disabled in WoW LUA so use SavedVariables on load/exit
	frame:RegisterEvent( "ADDON_LOADED")
end

function _G.LimitFunc.Guild( ... )
	local text, sender = ... --chat messages have this format
	
	if( sender == nil ) then
		return true --assume sucess if no sender
	end
	
	if( bVerbose == true ) then
		ChatFrame1:AddMessage( "Brigand_Chatterbox_IsGuild for " .. sender )
	end

	local result = false
	
	local num = GetNumGuildMembers()
	local guildieName
	for i = 1, num do
		guildieName = GetGuildRosterInfo( i )
		if (sender == guildieName ) then
			result = true
			break;
		end
	end

	return result
end

function _G.LimitFunc.Party( ... )
	local text, sender = ... --chat messages have this format
	
	if( sender == nil ) then
		return true --assume sucess if no sender
	end

	if( bVerbose == true ) then
		ChatFrame1:AddMessage( "Brigand_Chatterbox_IsParty for " .. sender )
	end

	local result = false
	
	local num = GetNumGroupMembers()
	local partyName
	for i = 1, num do
		partyName = UnitName( "party" .. i )
		if (sender == partyName ) then
			result = true
			break;
		end
	end

	return result
end

function _G.LimitFunc.Friend( ... )
	local text, sender = ... --chat messages have this format
	
	if( sender == nil ) then
		return true --assume sucess if no sender
	end

	if( bVerbose == true ) then
		ChatFrame1:AddMessage( "Brigand_Chatterbox_IsFriend for " .. sender )
	end

	local result = false
	
	local num = GetNumFriends()
	local friendName
	for i = 1, num do
		friendName = GetFriendInfo( i )
		if (sender == friendName ) then
			result = true
			break;
		end
	end

	return result
end

function _G.LimitFunc.NPC( ... )
	local text, sender = ... --chat messages have this format
		
	if( sender == nil ) then
		return true --assume sucess if no sender
	end

	if( bVerbose == true ) then
		ChatFrame1:AddMessage( "Brigand_Chatterbox_IsNPC for " .. sender )
	end
	
	local player = (UnitIsPlayer( sender ) ~= nil)
--ChatFrame1:AddMessage( "player: " .. tostring(player) )
	return player == false
end


function _G.LimitFunc.Target( ... )
	local unitID, spell = ... --Unit messages have this format
		
	if( unitID == nil ) then
		return true --assume sucess if no sender
	end

	spell = spell or "" --no nil
	
	if( bVerbose == true ) then
		ChatFrame1:AddMessage( "Brigand_Chatterbox_IsTarget for " .. unitID .." with " .. spell )
	end
	
	local unitName = UnitName( unitID ) or ""
	local targetName = UnitName( "target" ) or ""
	--local focusName = UnitName( "focus" ) or ""
	
	return (unitName == targetName) --or (unitName == focusName)
end

function Brigand_Chatterbox_OnEvent( self, event, ... )
	if (bVerbose) then
		ChatFrame1:AddMessage("Brigand_Chatterbox:OnEvent" .. event)
	end
	
	if (not bLoaded) then
		if (event == "ADDON_LOADED") then
			addon = ...
			if (addon == "Brigand_Chatterbox") then
				bLoaded = true
				--if (bVerbose) then
					ChatFrame1:AddMessage("|c0088ffffBrigand_Chatterbox:Loaded|r")
					--SendChatMessage( "May the stars guide you", "GUILD", nil, nil )
				--end
								
				--now that saved vars are loaded, "upgrade" to new defaults if not included
				if( _G.ChatVersion == nil ) then
					_G.ChatVersion = 0
				end
				if( _G.ChatVersion < tonumber(GetAddOnMetadata("Brigand_Chatterbox", "Version")) ) then -- upgrade necessary (could branch for specific fixes)
					for i = 1, #_G.DefaultChannel do
						--indexed by number
						if (_G.ChatChannel[i] == nil) then
							_G.ChatChannel[i] = _G.DefaultChannel[i]
						end
						
						--indexed by name
						if (_G.ChatEvent[_G.DefaultChannel[i]] == nil) then
							_G.ChatEvent[_G.DefaultChannel[i]] = _G.DefaultEvent[_G.DefaultChannel[i]]
						end
						
						if (_G.ChatSound[_G.DefaultChannel[i]] == nil) then
							_G.ChatSound[_G.DefaultChannel[i]] = _G.DefaultSound[_G.DefaultChannel[i]]
						end
						
						if (_G.ChatState[_G.DefaultChannel[i]] == nil) then
							_G.ChatState[_G.DefaultChannel[i]] = _G.DefaultState[_G.DefaultChannel[i]]
						end
						
						if (_G.ChatLimit[_G.DefaultChannel[i]] == nil) then
							_G.ChatLimit[_G.DefaultChannel[i]] = _G.DefaultLimit[_G.DefaultChannel[i]]
						end

					end
					
					_G.ChatVersion = tonumber(GetAddOnMetadata("Brigand_Chatterbox", "Version"))
				end
				
				--now register for the chat events we care about
				local eventName;
				for i = 1, #_G.ChatChannel do
					for eventName in _G.ChatEvent[_G.ChatChannel[i]]:gmatch("[%w_]+") do --multiple per channel
						self:RegisterEvent( eventName )
					end
				end
				
				-- optional registration with the "Portfoilio" library for "Options panel"
				PortfolioLib = LibStub and LibStub("Portfolio")
				Brigand_Chatterbox_RegisterOptionsTable()
			end --addon
		end --ADDON_LOADED
	else --bLoaded

		--one loop to rule them all...
		local eventName;
		for i = 1, #_G.ChatChannel do
			if( _G.ChatState[_G.ChatChannel[i]] ~= "0" ) then
				for eventName in _G.ChatEvent[_G.ChatChannel[i]]:gmatch("[%w_]+") do
					if( event == eventName ) then
						local bNeedsPlay = true --correct event
						for j = 1, #_G.LimitEnum do
							local limit = _G.ChatLimit[_G.ChatChannel[i]][_G.LimitEnum[j]]
							if( limit == "1" ) then
								bNeedsPlay = false --but limited
								if( _G.LimitFunc[_G.LimitEnum[j]](...) ) then
									bNeedsPlay = true --within limit
									break; --out of limits
								end
							end
						end --limit
						
						if( bNeedsPlay == true ) then --no limit or within limit
							local SoundType = _G.ChatState[_G.ChatChannel[i]]
							local SoundName = _G.ChatSound[_G.ChatChannel[i]]
							
							if( SoundType == "1" ) then --internal sound
								PlaySound( SoundName )
							else --"2" means external sound
								PlaySoundFile( SoundFilePrefix .. SoundName )
							end --state
						end --play
					end --name
				end --event
			end --off
		end --channel
		
		--hard-coded
		if( event == "MIRROR_TIMER_START" ) then
			_G.TimerType = ...
			_G.TimerTotal = 0 -- play first sound right-away
			_G.TimerStart = GetTime() --now
			_G.TimerCurrent = 0
--ChatFrame1:AddMessage( "TimerStart: " .. _G.TimerType );

		elseif( event == "MIRROR_TIMER_STOP" or event == "MIRROR_TIMER_PAUSE" ) then
			_G.TimerStart = 0
		end

	end --bLoaded
end

function Brigand_Chatterbox_OnUpdate( self, elapsed )
--ChatFrame1:AddMessage( "OnUpdate: " .. elapsed )
	if( _G.ChatState["Timer"] ~= "0" ) then
		if( _G.TimerStart > 0 ) then --a mirror timer (breath) is on
			_G.TimerCurrent = _G.TimerCurrent + elapsed --seconds
		
			if( _G.TimerCurrent >= _G.TimerTotal ) then
				if( _G.ChatState["Timer"] == "1" ) then
					PlaySound( _G.ChatSound["Timer"] )
				else
					PlaySoundFile( SoundFilePrefix .. _G.ChatSound["Timer"] )
				end
				
				--check values for next time
	--ChatFrame1:AddMessage( "OnUpdate GetMirrorTimerProgress: " .. _G.TimerType )
				local value = GetMirrorTimerProgress( _G.TimerType ) / 1000 --milliseconds
	--ChatFrame1:AddMessage( "OnUpdate TimerCurrent: " .. value )
				_G.TimerTotal = value / 15 --updates per minute (every 4 seconds)
				
				if( _G.TimerTotal > 5 ) then
					_G.TimerTotal = 5 --clamp to every 5 seconds until 1:15 left, then speed-up to every 4 at 1:00 remaining
				elseif( _G.TimerTotal < 1 ) then
					_G.TimerTotal = 1 --once per second at :15 left until death
				end
	--ChatFrame1:AddMessage( "TimerNext: " .. tostring(_G.TimerTotal) )
				_G.TimerCurrent = 0 --start over
			end
		end
	end --not "off"
end




function Brigand_Chatterbox_RegisterOptionsTable()
	if not PortfolioLib then return end
	
	local lastAnchor = nil;
	local optionNum=0;
	local suboptionNum = 0;

	--auto-construct table of options
	local Brigand_Chatterbox_OptionsTable =
	{
		id="Brigand_Chatterbox";
		addon="Brigand_Chatterbox"; --gets Title and Notes from metadata
		--title="Brigand Channels";
		subText="Sounds per Channel";
		about=false;
		options = {};
	}

	--CHANNELS sections
	
	for i = 1, #_G.ChatChannel do
		--header
		optionNum = optionNum+1
		Brigand_Chatterbox_OptionsTable.options[optionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].id = "SectionHeader_" .. _G.ChatChannel[i];
		Brigand_Chatterbox_OptionsTable.options[optionNum].text = _G.ChatName[_G.ChatChannel[i] ];
		Brigand_Chatterbox_OptionsTable.options[optionNum].type = CONTROLTYPE_HEADER;
		if( lastAnchor ~= nil ) then
			Brigand_Chatterbox_OptionsTable.options[optionNum].point = {nil, lastAnchor, nil, nil, nil};
		end
		
		--window
		optionNum = optionNum+1
		Brigand_Chatterbox_OptionsTable.options[optionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].id = "SectionWindow_" .. _G.ChatChannel[i];
		Brigand_Chatterbox_OptionsTable.options[optionNum].type = CONTROLTYPE_WINDOW;
		Brigand_Chatterbox_OptionsTable.options[optionNum].height = 200;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options = {}

		lastAnchor = Brigand_Chatterbox_OptionsTable.options[optionNum].id--.options[suboptionNum].id
		suboptionNum = 0
		--radios
		
		--off
		suboptionNum = suboptionNum+1
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Off";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatStateName[1];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].tooltipText = _G.ChatStateHelp[1];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_CHECKBOX;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].radio = true;
		if( _G.ChatState[_G.ChatChannel[i] ] == "0" ) then
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "1";
		else
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "0";
		end
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_RadioCB(_G.ChatChannel[i], "_Off", ...) end;
		
		--internal
		suboptionNum = suboptionNum+1
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Int";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatStateName[2];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].tooltipText = _G.ChatStateHelp[2] .. "\nTellMessage\nFriendJoinGame\nigPlayerInvite\ngsTitleQuit\nMINIMAPOPEN";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_CHECKBOX;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].radio = true;

		if( _G.ChatState[_G.ChatChannel[i] ] == "1" ) then
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "1";
		else
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "0";
		end
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_RadioCB(_G.ChatChannel[i], "_Int", ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {"LEFT", _G.ChatChannel[i] .. "_Off", "RIGHT", 100, 0};
		
		--external
		suboptionNum = suboptionNum+1
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Ext";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatStateName[3];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].tooltipText = _G.ChatStateHelp[3];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_CHECKBOX;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].radio = true;

		if( _G.ChatState[_G.ChatChannel[i] ] == "2" ) then
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "1";
		else
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "0";
		end
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_RadioCB(_G.ChatChannel[i], "_Ext", ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {"LEFT", _G.ChatChannel[i] .. "_Int", "RIGHT", 100, 0};
		
		--sound
		suboptionNum = suboptionNum+1
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Sound";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].headerText = _G.ChatSoundName;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_EDITBOX;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].width = 300;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = _G.ChatSound[_G.ChatChannel[i] ];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_Sound_EditCB(_G.ChatChannel[i], ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {nil, _G.ChatChannel[i] .. "_Off", nil, nil, nil};
				
		--picker
		suboptionNum = suboptionNum+1
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Picker";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].headerText = _G.ChatSoundPickerName;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_DROPDOWN;

		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "0";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].menuList =
		{
			{
				isTitle = 1;
				text = _G.ChatSoundPickerTitle;
			};

		};
--ChatFrame1:AddMessage("InternalSoundCategory #" .. tostring(#_G.InternalSoundCategory) );
		for i = 1, #_G.InternalSoundCategory do
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].menuList[i+1] = {};
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].menuList[i+1].text = _G.InternalSoundCategory[i];
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].menuList[i+1].hasArrow = true;
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].menuList[i+1].menuList = {};
--ChatFrame1:AddMessage("InternalSoundCategory #" .. tostring(#_G.InternalSoundList[_G.InternalSoundCategory[i]]) );
			for j = 1, #_G.InternalSoundList[_G.InternalSoundCategory[i]] do
				Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].menuList[i+1].menuList[j] = {};
				Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].menuList[i+1].menuList[j].text = _G.InternalSoundList[_G.InternalSoundCategory[i]][j];
				Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].menuList[i+1].menuList[j].value = i*100+j;
			end
		end

		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_Sound_DropdownCB( _G.ChatChannel[i], "_Picker", ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {nil, _G.ChatChannel[i] .. "_Sound", nil, nil, nil};

		--test
		suboptionNum = suboptionNum+1
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Btn";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatSoundButtonName;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_BUTTON;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_TestCB(_G.ChatChannel[i], ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {"LEFT", _G.ChatChannel[i] .. "_Picker", "RIGHT", 25, 0};
		
		--limits title
		suboptionNum = suboptionNum+1
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Limit";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatLimitTitle;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_TEXT;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {nil, _G.ChatChannel[i] .. "_Picker", nil, nil, nil};
				
		--limits checkboxes

		--guild
		suboptionNum = suboptionNum+1
		local limit = _G.ChatLimit[_G.ChatChannel[i] ].Guild
		
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Guild";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatLimitName[1];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].tooltipText = _G.ChatLimitHelp[1];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_CHECKBOX;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "0";
		if( limit == "-1" ) then
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].enabled = false;
		else
			if( limit == "1" ) then
				Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "1";
			end
		end
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_LimitCB(_G.ChatChannel[i], "Guild", ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {"LEFT", _G.ChatChannel[i] .. "_Limit", "LEFT", 75, 0}; --text RIGHT is bad?
		
		--party
		suboptionNum = suboptionNum+1
		limit = _G.ChatLimit[_G.ChatChannel[i] ].Party

		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Party";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatLimitName[2];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].tooltipText = _G.ChatLimitHelp[2];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_CHECKBOX;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "0";
		if( limit == "-1" ) then
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].enabled = false;
		else
			if( limit == "1" ) then
				Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "1";
			end
		end
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_LimitCB(_G.ChatChannel[i], "Party", ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {"LEFT", _G.ChatChannel[i] .. "_Guild", "RIGHT", 65, 0};
		
		--friend
		suboptionNum = suboptionNum+1
		limit = _G.ChatLimit[_G.ChatChannel[i] ].Friend

		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Friend";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatLimitName[3];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].tooltipText = _G.ChatLimitHelp[3];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_CHECKBOX;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "0";
		if( limit == "-1" ) then
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].enabled = false;
		else
			if( limit == "1" ) then
				Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "1";
			end
		end
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_LimitCB(_G.ChatChannel[i], "Friend", ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {"LEFT", _G.ChatChannel[i] .. "_Party", "RIGHT", 65, 0};
		
		--NPC
		suboptionNum = suboptionNum+1
		limit = _G.ChatLimit[_G.ChatChannel[i] ].NPC

		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_NPC";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatLimitName[4];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].tooltipText = _G.ChatLimitHelp[4];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_CHECKBOX;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "0";
		if( limit == "-1" ) then
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].enabled = false;
		else
			if( limit == "1" ) then
				Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "1";
			end
		end
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_LimitCB(_G.ChatChannel[i], "NPC", ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {"LEFT", _G.ChatChannel[i] .. "_Friend", "RIGHT", 65, 0};
		
		--Target
		suboptionNum = suboptionNum+1
		limit = _G.ChatLimit[_G.ChatChannel[i] ].Target

		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum] = {};
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].id = _G.ChatChannel[i] .. "_Target";
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].text = _G.ChatLimitName[5];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].tooltipText = _G.ChatLimitHelp[5];
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].type = CONTROLTYPE_CHECKBOX;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "0";
		if( limit == "-1" ) then
			Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].enabled = false;
		else
			if( limit == "1" ) then
				Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].defaultValue = "1";
			end
		end
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].callback = function(...) Brigand_Chatterbox_LimitCB(_G.ChatChannel[i], "Target", ...) end;
		Brigand_Chatterbox_OptionsTable.options[optionNum].options[suboptionNum].point = {"LEFT", _G.ChatChannel[i] .. "_NPC", "RIGHT", 65, 0};
	end --channel
	
	optionsFrameID = PortfolioLib.RegisterOptionSet(Brigand_Chatterbox_OptionsTable); --global
end


function Brigand_Chatterbox_Sound_DropdownCB( group, id, value, isGUI, isUpdate )
--ChatFrame1:AddMessage( "Brigand_Chatterbox_Sound_DropdownCB" );
	local control = PortfolioLib.GetControl( optionsFrameID, group .. id )
	local ValueInfo = control.GetValueInfo( control, value )
	if( ValueInfo ~= nil ) then
		local SoundName = ValueInfo.text
		if( SoundName ~= nil ) then
			if( SoundName ~= "" ) then
--ChatFrame1:AddMessage( "Brigand_Chatterbox_Sound_DropdownCB: picked sound" .. SoundName );
				control = PortfolioLib.GetControl( optionsFrameID, group .. "_Sound" )
				control.SetText(control, SoundName)
			end
		end
	end
end

function Brigand_Chatterbox_RadioCB(group, id, value, isGUI, isUpdate) 
	if( bVerbose ) then 
		PortfolioLib.Print(group .. " " .. id .. " callback( \""..tostring(value).."\", "..tostring(isGUI)..", "..tostring(isUpdate)..")");
	end
	
	--radiobutton-like behavior
--	local window = PortfolioLib.GetControl( optionsFrameID, "SectionWindow_" .. group )
	local control;
	
	if( value == "0" and isGUI ) then
		control = PortfolioLib.GetControl( optionsFrameID, group .. id );
		control.SetValue( control, "1" ); --cannot "turn off"
	end
	
	if( value == "1" ) then
		if( id == "_Off" ) then
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Int" )
			control.SetValue(control,"0",false,false);
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Ext" )
			control.SetValue(control,"0",false,false);
			
			_G.ChatState[group] = "0"; --off
			local pick = PortfolioLib.GetControl( optionsFrameID, group .. "_Picker" );
--			pick.Disable( pick );
			local test = PortfolioLib.GetControl( optionsFrameID, group .. "_Btn" );
			test.Disable( test );
			
		elseif( id == "_Int" ) then
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Off" )
			control.SetValue(control,0);
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Ext" )
			control.SetValue(control,0);
			
			_G.ChatState[group] = "1"; --internal
			local pick = PortfolioLib.GetControl( optionsFrameID, group .. "_Picker" );
--			pick.Enable( pick );
			local test = PortfolioLib.GetControl( optionsFrameID, group .. "_Btn" );
			test.Enable( test );
			
		elseif( id == "_Ext" ) then
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Off" )
			control.SetValue(control,"0",false,false);
			control = PortfolioLib.GetControl( optionsFrameID, group .. "_Int" )
			control.SetValue(control,"0",false,false);
						
			_G.ChatState[group] = "2"; --external
			local pick = PortfolioLib.GetControl( optionsFrameID, group .. "_Picker" );
--			pick.Disable( pick );
			local test = PortfolioLib.GetControl( optionsFrameID, group .. "_Btn" );
			test.Enable( test );
		end
	end
end

function Brigand_Chatterbox_LimitCB(group, id, value, isGUI, isUpdate) 
	if( bVerbose ) then 
		PortfolioLib.Print(group .. " " .. id .. " callback( \""..tostring(value).."\", "..tostring(isGUI)..", "..tostring(isUpdate)..")");
	end

	local control = PortfolioLib.GetControl( optionsFrameID, group .. "_" .. id)
	if( control.IsEnabled(control) ) then
		_G.ChatLimit[group][id] = value;
	end
end

function Brigand_Chatterbox_Sound_EditCB(group, value, isGUI, isUpdate) 
	if (bVerbose) then 
		PortfolioLib.Print(group.." callback( \""..tostring(value).."\", "..tostring(isGUI)..", "..tostring(isUpdate)..")");
	end
	
--	local window = PortfolioLib.GetControl( optionsFrameID, "SectionWindow_" .. group );
	local sound = PortfolioLib.GetControl( optionsFrameID, group .. "_Sound" );
	_G.ChatSound[group] = sound.GetText( sound );
end

function Brigand_Chatterbox_TestCB(group, value, isGUI, isUpdate) 
	if (bVerbose) then 
		PortfolioLib.Print(group.." callback( \""..tostring(value).."\", "..tostring(isGUI)..", "..tostring(isUpdate)..")");
	end
	
	if (_G.ChatState[group] == "1") then --internal sound
		PlaySound( _G.ChatSound[group] )
	else --"2" means external sound
		PlaySoundFile( SoundFilePrefix .. _G.ChatSound[group] )
	end
end
